//----------------------------------------------------------------
// GUI Frame for aflsning af termometer
// Programmr: Bjrk Busch nov.1999
//----------------------------------------------------------------

import javabook.Convert;
import javabook.Format;
import java.awt.event.*;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.awt.Choice;
import java.awt.Button;
import java.awt.Label;
import java.awt.TextField;

public	class GuiAflaesFrame extends Frame
{
  // Skrmdata
  private JPanel      panel0        = new JPanel ();
  private JPanel      panel1        = new JPanel ();
  private JPanel      panel1a       = new JPanel ();
  private JPanel      panel1b       = new JPanel ();
  private JPanel      panel1c       = new JPanel ();
  private JPanel      panel3        = new JPanel ();

  private Label       labelAktuel   = new Label ("Aktuel temperatur:");
  private Label       labelMin      = new Label ("Minimum temperatur:");
  private Label       labelMax      = new Label ("Maksimum temperatur:");
  private TextField   aktuelt       = new TextField ("",30);
  private TextField   min           = new TextField ("",30);
  private TextField   max           = new TextField ("",30);
  private Choice      outEnhed      = new Choice();
  private Choice      outTermometerNavn	= new Choice();

  private Button      aflaes        = new Button ("Afls termometer");
  private Button      clear         = new Button ("Clear Min/Max");

  private Button      afslut            = new Button ("Aflut");


  //	Model-komponent
  private Termometer []	termometer      = { new Termometer(), new Termometer() };
  private String []     termometerNavn  = { "Indendrs", "Udendrs" };


  public GuiAflaesFrame (Termometer[]	termometer, String [] termometerNavn) /* constructor */
  {

    this.termometer			= termometer;	// gem reference til model
    this.termometerNavn		= termometerNavn;	// gem reference til model

    // opbygning af skrmbillede
    setSize(600,220);
    setTitle("TermometerProgram");

    setLayout(new GridLayout(1,1));         
    panel0.setLayout(null);          
    add(panel0);

    panel1.setBounds(5,5,500,200);
    panel1.setBorder(new TitledBorder(new EtchedBorder(),"Termometer aflsning"));
    panel1.setLayout(new GridLayout(1,3));          
    panel0.add(panel1);

    panel1a.setLayout(new GridLayout(4,1));         
    panel1.add(panel1a);
    panel1a.add(labelAktuel);
    panel1a.add(labelMin);
    panel1a.add(labelMax);

    aktuelt.setEditable(false);
    aktuelt.setEnabled(false);
    min.setEditable(false);
    min.setEnabled(false);
    max.setEditable(false);
    max.setEnabled(false);

    panel1b.setLayout(new GridLayout(4,1));         
    panel1.add(panel1b);
    panel1b.add(aktuelt);
    panel1b.add(min);
    panel1b.add(max);
    outEnhed.addItem("Celcius");
    outEnhed.addItem("Fahrenheit");
    outEnhed.select(0);
    panel1b.add(outEnhed);

    panel1c.setLayout(new GridLayout(4,1));         
    panel1.add(panel1c);
    panel1c.add(aflaes);
    aflaes.addActionListener(new AflaesKnapActionListener());
    panel1c.add(clear);
    clear.addActionListener(new ClearKnapActionListener());
    panel1c.add(new Label (""));	// fyld
    for (int i = 0; i < termometerNavn.length; i++)
    {
	        outTermometerNavn.addItem(termometerNavn[i]);
    }
    outTermometerNavn.select(0);
    panel1c.add(outTermometerNavn);


    panel3.setBounds(505,5,85,200);
    panel3.setBorder(new TitledBorder(new EtchedBorder()," "));
    panel3.setLayout(new GridLayout(6,1));          
    panel0.add(panel3);

    panel3.add(afslut);
    afslut.addActionListener(new AfslutKnapActionListener());

    setVisible(true);

  }

  private void aflaesTermometer ()
  {
    Termometer term = termometer[outTermometerNavn.getSelectedIndex()];
    Temperatur	tempakt = term.getTemperatur();
    Temperatur	tempmin = term.getMinTemperatur();
    Temperatur	tempmax = term.getMaxTemperatur();
    if (((String)outEnhed.getSelectedItem()).equals("Fahrenheit"))
    {
      aktuelt.setText(Format.rightAlign(30,3,tempakt.getFahrenheit()));
      min.setText(Format.rightAlign(30,3,tempmin.getFahrenheit()));
      max.setText(Format.rightAlign(30,3,tempmax.getFahrenheit()));
    }
    else
    {
      aktuelt.setText(Format.rightAlign(30,3,tempakt.getCelcius()));
      min.setText(Format.rightAlign(30,3,tempmin.getCelcius()));
      max.setText(Format.rightAlign(30,3,tempmax.getCelcius()));
    }
  }

  private void clearTermometer ()
  {
    Termometer term = termometer[outTermometerNavn.getSelectedIndex()];
    term.clearMinMax();
    aktuelt.setText("");
    min.setText("");
    max.setText("");
  }

  private void luk ()
  {
    System.exit(0);   // hvis Frame skal lukkes, men program ikke skal stoppes bruges
                      // dispose();
  }

  private	class AfslutKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
  	  luk();
    }
  }

  private	class AflaesKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
  	{
      aflaesTermometer ();
  	}
  }
  private	class ClearKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
  	{
      clearTermometer ();
  	}
  }


} // slut p frame-klasse
