//----------------------------------------------------------------
// GUI Frame for opdatering af termometer
// Programmr: Bjrk Busch nov.1999
//----------------------------------------------------------------

import javabook.Convert;
import javabook.Format;
import java.awt.event.*;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.awt.Choice;
import java.awt.Button;
import java.awt.Label;
import java.awt.TextField;

public	class GuiOpdaterFrame extends Frame
{
  // Skrmdata
  private JPanel      panel0        = new JPanel ();
  private JPanel      panel2        = new JPanel ();
  private JPanel      panel2a       = new JPanel ();
  private JPanel      panel2b       = new JPanel ();
  private JPanel      panel3        = new JPanel ();

  private Label       labelNyTemperatur	= new Label ("Ny temperaturmling:");
  private TextField   nyTemperatur      = new TextField ("",30);
  private Choice      inEnhed           = new Choice();
  private Button      opdater           = new Button ("Opdater termometer");

  private Button      afslut            = new Button ("Aflut");

  //	Model-komponent
  private Termometer  termometer;
  private String      termometerNavn;

  public GuiOpdaterFrame (Termometer termometer, String termometerNavn) /* constructor */
  {

    this.termometer		 	= termometer;		// gem reference til model
    this.termometerNavn 	= termometerNavn;	// gem reference til model

    // opbygning af skrmbillede
    setSize(600,170);
    setTitle("TermometerProgram");

    setLayout(new GridLayout(1,1));         
    panel0.setLayout(null);          
    add(panel0);

    panel2.setBounds(5,5,500,150);
    panel2.setBorder(new TitledBorder(new EtchedBorder(),"Termometer opdatering for "+termometerNavn+"-termometer"));
    panel2.setLayout(new GridLayout(1,2));          
    panel0.add(panel2);

    panel2a.setLayout(new GridLayout(3,1));         
    panel2.add(panel2a);
    panel2a.add(labelNyTemperatur);
    panel2a.add(nyTemperatur);

    inEnhed.addItem("Celcius");
    inEnhed.addItem("Fahrenheit");
    inEnhed.select(0);

    panel2a.add(inEnhed);

    panel2b.setLayout(new GridLayout(3,1));         
    panel2.add(panel2b);

    panel2b.add(new Label (""));	// fyld
    panel2b.add(opdater);
    opdater.addActionListener(new OpdaterKnapActionListener());

    panel3.setBounds(505,5,85,150);
    panel3.setBorder(new TitledBorder(new EtchedBorder()," "));
    panel3.setLayout(new GridLayout(4,1));          
    panel0.add(panel3);

    panel3.add(afslut);
    afslut.addActionListener(new AfslutKnapActionListener());

    setVisible(true);

  }

  private void opdaterTermometer ()
  {
    Temperatur	temp = new Temperatur();
    if (((String)inEnhed.getSelectedItem()).equals("Fahrenheit"))
      temp.setFahrenheit(Convert.toFloat(nyTemperatur.getText()));
    else
      temp.setCelcius(Convert.toFloat(nyTemperatur.getText()));
    termometer.setTemperatur(temp);
  }

  private void luk ()
  {
    this.dispose();
  }

  private	class AfslutKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
  	  luk();
    }
  }

  private	class OpdaterKnapActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
  	{
      opdaterTermometer ();
  	}
  }


} // slut p frame-klasse
